/*
 *
 *  Copyright Peter Boyle and Glasgow University 2000. 
 *  This software is provided for NON-COMMERCIAL use only,
 *  and may not be redistributed without permission.
 *  It is provided as is and is not guaranteed fit for any purpose.
 *
 */


#include "processor.h"
extern struct processor *PROC;


/* {...IMMEDIATE offset management routines*/

struct offset *offset_list = NULL;
int def_offset ( int units,const char *str ) 
{
  struct offset *new = malloc ( sizeof(struct offset));
  struct offset *search;
  int handle;

  test_proc();
  new -> offst = units * PROC->FP_size;
  new -> name = str;
  new -> next = NULL;

  handle = 0;
  if ( offset_list == NULL ) {
    offset_list = new;
    return( handle);
  }
  search  = offset_list;
  while ( search-> next != NULL ) {
    handle ++;
    search = search -> next;
  }

  /*Add to end of list*/
  search->next = new;
  handle ++;

  return(handle);  
}
int get_offset( int handle ) 
{
  if ( handle < 0 ) { 
    fprintf(stderr,"Bad handle passed to get_offset\n");
    exit(-1);
  }
  return( get_offset_struct(handle) -> offst );
}

int def_byte_offset ( int units,const char *str ) 
{
  struct offset *new = malloc ( sizeof(struct offset));
  struct offset *search;
  int handle;

  test_proc();
  new -> offst = units;
  new -> name = str;
  new -> next = NULL;

  handle = 0;
  if ( offset_list == NULL ) {
    offset_list = new;
    return( handle);
  }
  search  = offset_list;
  while ( search-> next != NULL ) {
    handle ++;
    search = search -> next;
  }

  /*Add to end of list*/
  search->next = new;
  handle ++;

  return(handle);  
}


const char * get_offset_name ( int handle )
{
  return( get_offset_struct(handle) -> name );
}

struct offset * get_offset_struct( int handle )
{
  struct offset * search;
  int count;

  count = 0 ;
  search = offset_list;

  while ( count != handle && search != NULL) {
    search = search -> next;
    count ++;
  }
  return ( search);
}
/* ...}*/
